
#include <pcap.h>

#include "amesis.h"
#include "dumper.h"

int
dump_packet(pifs tab_if, const unsigned char *pack, struct pcap_pkthdr h)
{
	unsigned int i, j;
	unsigned int reste, fin;

	pack += tab_if->linkh_len;

	if ((unsigned int)pcap_snapshot(tab_if->pfd) < h.caplen)
		reste = pcap_snapshot(tab_if->pfd) - tab_if->linkh_len;
	else
		reste = h.caplen - tab_if->linkh_len;
	
	for (j = 0; reste != 0; j += 16) {
		fin = ((reste > 16)?16:reste);
		for (i = 0; i < fin ; i += 2) { 
			if ((fin - i) == 1)
				printf("%.2x", *(pack + i + j));
			else
				printf("%.2x%.2x ", *(pack + i + j), 
				       *(pack + i + j + 1));
		}
		printf("\n");
		reste -= (i - (i - fin));
	}
	printf("\n");

	return 0;
}
